const Times = require("./times")
const DBPool = require("./mysql")

class Service {
    constructor(){
        this.hashratedb = new DBPool("nexa", {  
            "host": "13.213.4.56",
            "user": "root",
            "password": "123456",
            "database": "hashrate",
            "port":6789,
            "waitForConnections": true,
            "connectionLimit": 20,
            "queueLimit": 0
        })
        
        this.distributiondb = new DBPool("nexa", {
            "host": "13.213.4.56",
            "user": "root",
            "password": "123456",
            "database": "distribution",
            "port":6789,
            "waitForConnections": true,
            "connectionLimit": 20,
            "queueLimit": 0
        })
    }

    async query_distribution(date){
        date = date + " 00:00:00"
        try{
            const sql = `SELECT create_date AS date, coin, user, amount, address FROM wallet_in WHERE create_date = ?;`
            const data = await this.distributiondb.exec(sql, [date])
            if(!data || data.length === 0){
                return false
            }
            return data
        } catch(err){
            throw err
        }
    }

    async query_hashrate(date){
        date = date + " 00:00:00"
        try{
            const coins = ["nexa", "grs", "mona", "dgbo", "dgbq", "dgbs", "rxd"]
            const result = []
            for(let i=0; i<coins.length; i++){
                const sql = `SELECT date, user, SUM(mhs24h) AS mhs24h FROM ${coins[i]}_mhsv2 WHERE date = ? GROUP BY date, user;`
                const data = await this.hashratedb.exec(sql, [date])
                for(let item of data){
                    result.push({date:item.date, user:item.user, coin: coins[i], mhs24h:item.mhs24h})
                }
            }
            if(!result || result.length === 0){
                return false
            }
            return result
        } catch(err){
            throw err
        }
    }

    async query_total_blockreward(date){
        date = date + " 00:00:00"
        let param_date = Times.utcTime(new Date(date).valueOf() - 86400000)
        param_date = param_date.split(" ")[0]
        try{
            const coins = ["nexa", "grs", "mona", "dgbo", "dgbq", "dgbs", "rxd"]
            const result = []
            for(let i=0; i<coins.length; i++){
                const sql = `SELECT SUM(reward) AS reward FROM ${coins[i]}_blkreportprofitv2 WHERE DATE(date) = ? AND state = ?;`
                const data = await this.distributiondb.exec(sql, [param_date, 1])
                for(let item of data){
                    result.push({date, coin:coins[i], reward:item.reward})
                }
            }
            if(!result || result.length === 0){
                return false
            }
            return result
        } catch(err){
            throw err
        }
    }

    async query_walletout(date){
        date = date + " 00:00:00"
        try{
            const sql = `SELECT * FROM wallet_outv2 WHERE date = ?;`
            const data = await this.distributiondb.exec(sql, [date])
            if(!data || data.length === 0){
                return false
            }
            return data
        } catch(err){
            throw err
        }
    }
}

module.exports = Service